package ar.edu.unju.fi.poo.champions.entity;

import jakarta.persistence.*;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@AllArgsConstructor
@NoArgsConstructor
@Entity
public class Player {
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private Long id;

	@Column(name = "name", length = 50)
	private String name;

	@Column(name = "number")
	private int number;

	@Column(name = "position", length = 50)
	private String position;

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "team_id", nullable = false)
	private Team team;

	@Override
	public String toString() {
		return "Player [id=" + id + ", name=" + name + ", number=" + number + ", position=" + position + ", team="
				+ team + "]";
	}

}
