package ar.edu.unju.fi.poo.champions.service.impl;

import ar.edu.unju.fi.poo.champions.entity.Player;
import ar.edu.unju.fi.poo.champions.entity.Team;
import ar.edu.unju.fi.poo.champions.repository.PlayerRepository;
import ar.edu.unju.fi.poo.champions.repository.TeamRepository;
import ar.edu.unju.fi.poo.champions.service.SoccerService;
import ar.edu.unju.fi.poo.champions.service.dto.request.PlayerDTO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Optional;

@Service
public class SoccerServiceImpl implements SoccerService {
	@Autowired
	private PlayerRepository playerRepository;
	@Autowired
	private TeamRepository teamRepository;

	/**
	 * 
	 * @param teamId
	 * @return
	 */
	@Override
	public List<PlayerDTO> getAllTeamPlayers(long teamId) {
		// FIXME debe implemantar ModelMapper para convertir entities en DTOs

		List<Player> players = playerRepository.findByTeamId(teamId);
		List<PlayerDTO> dtos = new ArrayList<PlayerDTO>();
		for (Player p : players) {
			PlayerDTO dto = new PlayerDTO();
			dto.setId(p.getId());
			dto.setName(p.getName());
			dto.setNumber(p.getNumber());
			dto.setPosition(p.getPosition());
			dto.setTeamId(p.getTeam().getId());
			dtos.add(dto);
		}
		return dtos;
	}

	/**
	 * @author jzapana
	 * @param playerDto
	 */
	@Override
	public PlayerDTO addPlayerToTeam(PlayerDTO playerDto) {

		Optional<Team> barcelona = teamRepository.findById(playerDto.getTeamId());

		Player newPlayer = new Player();
		newPlayer.setId(playerDto.getId());
		newPlayer.setName(playerDto.getName());
		newPlayer.setPosition(playerDto.getPosition());
		newPlayer.setNumber(playerDto.getNumber());
		newPlayer.setTeam(barcelona.get());

		newPlayer = playerRepository.save(newPlayer);
		PlayerDTO dto = new PlayerDTO();
		dto.setId(newPlayer.getId());
		dto.setName(newPlayer.getName());
		dto.setNumber(newPlayer.getNumber());
		dto.setPosition(newPlayer.getPosition());
		dto.setTeamId(newPlayer.getTeam().getId());
		return dto;
	}

	public PlayerDTO updatePlayer(PlayerDTO playerDto) {

		Optional<Team> barcelona = teamRepository.findById(playerDto.getTeamId());
		Player entity = new Player();
		entity.setId(playerDto.getId());
		entity.setName(playerDto.getName());
		entity.setPosition(playerDto.getPosition());
		entity.setNumber(playerDto.getNumber());
		entity.setTeam(barcelona.get());

		playerRepository.save(entity);
		return playerDto;
	}
}
